#ifndef STD0X_COMMON_TYPE_H
#define STD0X_COMMON_TYPE_H
#pragma once

#ifndef BOOST_TYPEOF_SILENT
#define BOOST_TYPEOF_SILENT
#include <boost/typeof/typeof.hpp>
#undef BOOST_TYPEOF_SILENT
#else
#include <boost/typeof/typeof.hpp>
#endif

namespace std0x {

template <class T, class U = void, class V = void>
struct common_type {
public:
  typedef typename common_type<typename common_type<T, U>::type, V>::type type;
}; // common_type

template <class T>
struct common_type<T, void, void> {
public:
  typedef T type;
}; // common_type

template <class T, class U>
struct common_type<T, U, void> {
private:
  static T m_t();
  static U m_u();
  static bool m_f();  // workaround gcc bug
public:
  typedef BOOST_TYPEOF_TPL(m_f() ? m_t() : m_u()) type;
}; // common_type

} // std0x

#endif
