// (c) Copyright 2010 Terry Golubiewski, all rights reserved.

#ifndef CARTESIAN_IO_H
#define CARTESIAN_IO_H
#pragma once

#include <cartesian/Vector.h>
#include <cartesian/point.h>
#include <ostream>

namespace cartesian {

template<class Ch, class Tr, int Dim, class Rep> inline
std::basic_ostream<Ch, Tr>&
operator<<(std::basic_ostream<Ch, Tr>& os, const vector<Dim, Rep>& v) {
  os << '<' << v[0];
  for (int i=1; i!=Dim; ++i)
    os << ' ' << v[i];
  return os << '>';
} // << vector<Dim, Rep>

template<class Ch, class Tr, int Dim, class Rep, class Ref> inline
std::basic_ostream<Ch, Tr>&
operator<<(std::basic_ostream<Ch, Tr>& os, const point<Dim, Rep, Ref>& p) {
  os << '(' << p[0];
  for (int i=1; i!=Dim; ++i)
    os << ' ' << p[i];
  return os << ')';
} // << point<Dim, Rep, Ref>

} // cartesian

#endif
